<?php
include_once(DIR_FS_CATALOG.'ext/modules/payment/alternative_payments/helper/AlternativePaymentsInclude.php');

if (!defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH')) {
    DEFINE('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH',
        'ext/modules/payment/alternative_payments/image/');
}

class AlternativePaymentsFunctions
{
    public static function install_fields()
    {
        /** Value not-used defined that key don't need to use */
        $payment_options = AlternativePaymentsPayment::get_payment_options();
        $install         = array();

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_STATUS'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_enable_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_STATUS',
            'configuration_value' => 'True',
            'configuration_description' => 'Do you want to accept Alternative Payments?',
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'tep_cfg_select_option(array("True", "False"), ',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_TITLE'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_title_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_TITLE',
            'configuration_value' => AlternativePaymentsText::en('form_field_title_default'),
            'configuration_description' => AlternativePaymentsText::en('form_field_title_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SMS_VERIFICATION'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_sms_verification_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SMS_VERIFICATION',
            'configuration_value' => AlternativePaymentsText::en('sms_active_default_value'),
            'configuration_description' => AlternativePaymentsText::en('sms_active_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'alternative_payments::get_alternative_payment_merchant_get_sms_verification(',
            'use_function' => 'not-used',
            'date_added' => 'now()'

        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PRODUCT_KEY'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_product_key_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PRODUCT_KEY',
            'configuration_value' => '',
            'configuration_description' => AlternativePaymentsText::en('form_field_product_key_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SECRET_KEY'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_api_key_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SECRET_KEY',
            'configuration_value' => '',
            'configuration_description' => AlternativePaymentsText::en('form_field_api_key_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_API_URL'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_api_url_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_API_URL',
            'configuration_value' => AlternativePaymentsText::en('form_field_api_url_default'),
            'configuration_description' => AlternativePaymentsText::en('form_field_api_url_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_RETURN_URL'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_return_url_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_RETURN_URL',
            'configuration_value' => AlternativePaymentsText::en('form_field_return_url_default'),
            'configuration_description' => AlternativePaymentsText::en('form_field_return_url_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_CANCEL_URL'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_cancel_url_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_CANCEL_URL',
            'configuration_value' => AlternativePaymentsText::en('form_field_cancel_url_default'),
            'configuration_description' => AlternativePaymentsText::en('form_field_cancel_url_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_MERCHANT_TOOL_STATUS'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_proccessing_status_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_MERCHANT_TOOL_STATUS',
            'configuration_value' => AlternativePaymentsText::en('form_field_proccessing_status_default'),
            'configuration_description' => AlternativePaymentsText::en('form_field_proccessing_status_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'alternative_payments::get_alternative_payment_merchant_tool_status(',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_DESCRIPTION'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_description_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_DESCRIPTION',
            'configuration_value' => AlternativePaymentsText::en('form_field_description_description'),
            'configuration_description' => AlternativePaymentsText::en('form_field_description_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_INSTRUCTIONS'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_instructions_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_INSTRUCTIONS',
            'configuration_value' => AlternativePaymentsText::en('form_field_instructions_description'),
            'configuration_description' => AlternativePaymentsText::en('form_field_instructions_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PAYMENT_OPTIONS'] = array(
            'configuration_title' => AlternativePaymentsText::en('form_field_payment_options_title'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PAYMENT_OPTIONS',
            'configuration_value' => 'not-used',
            'configuration_description' => AlternativePaymentsText::en('form_field_payment_options_description'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'non',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        foreach ($payment_options as $payment) {
            $name   = 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PAYMENT_OPTIONS';
            $p_id   = strtoupper($payment['id']);
            $p_name = $name.'_'.$p_id;

            $install[$p_name] = array(
                'configuration_title' => $payment['payment_name'],
                'configuration_key' => $p_name,
                'configuration_value' => 'Inactive',
                'configuration_description' => 'not-used',
                'configuration_group_id' => '7',
                'sort_order' => '0',
                'set_function' => 'tep_cfg_select_option(array("Active", "Inactive"), ',
                'use_function' => 'not-used',
                'date_added' => 'now()'
            );
        }

        $install['MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SORT_ORDER'] = array(
            'configuration_title' => AlternativePaymentsText::en('text_sort_order'),
            'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SORT_ORDER',
            'configuration_value' => AlternativePaymentsText::en('entry_sort_order'),
            'configuration_description' => AlternativePaymentsText::en('help_sort_order'),
            'configuration_group_id' => '7',
            'sort_order' => '0',
            'set_function' => 'not-used',
            'use_function' => 'not-used',
            'date_added' => 'now()'
        );

        /* $install[''] = array(
          'configuration_title' => '',
          'configuration_key' => '',
          'configuration_value' => '',
          'configuration_description' => '',
          'configuration_group_id' => '7',
          'sort_order' => '0',
          'set_function' => '',
          'use_function' => '',
          'date_added' => 'now()'
          ); */

        return $install;
    }

    public static function config_set()
    {
        $config = new AlternativePaymentsConfig();

        $api_key = self::get_config_value(array('configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SECRET_KEY'));
        $config->setApiKey($api_key);

        $product_key = self::get_config_value(array('configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PRODUCT_KEY'));
        $config->setProductKey($product_key);

        $api_url = self::get_config_value(array('configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_API_URL'));
        $config->setApiUrl($api_url);

        $db_return_url = self::get_config_value(array('configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_RETURN_URL'));
        $return_url    = $db_return_url ? $db_return_url : tep_href_link('checkout_success.php');
        $config->setReturnUrl($return_url);

        $db_cancel_url = self::get_config_value(array('configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_CANCEL_URL'));
        $cancel_url    = $db_cancel_url ? $db_cancel_url : tep_href_link(FILENAME_CHECKOUT_PAYMENT);
        $config->setCancelUrl($cancel_url);

        return $config;
    }

    public static function get_config_value($opt = null)
    {
        $opt = array(
            'configuration_key' => isset($opt['configuration_key']) ? $opt['configuration_key']
                : '',
        );

        $return = '';

        $sql = tep_db_query("SELECT `configuration_key`, `configuration_value` FROM ".TABLE_CONFIGURATION." WHERE configuration_key = '".$opt['configuration_key']."'");

        while ($row = tep_db_fetch_array($sql)) {
            $return[] = $row['configuration_value'];
        }

        return isset($return[0]) ? $return[0] : false;
    }

    public function getOrderItems($invoice)
    {
        $items  = $invoice['products'];
        $return = '';
        foreach ($items as $item) {
            $return .= sprintf(AlternativePaymentsText::en('send_merchant_tool_items'),
                $item['name'], $item['id'], $item['qty'],
                $item['final_price'].$invoice['order']['currency']
            );
        }
        return $return;
    }

    public function getUserIp()
    {
        AlternativePaymentsTransaction::saveDataToTblLog('Helper_Payment',
            'getUserIp');
        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
        return $ip;
    }

    public function decode_amount($data)
    {
        $data = number_format($data, 2, '.', ',');
        $data = str_replace(',', '', $data);
        return $data * 100;
    }

    public function encode_amount($data)
    {
        $data = $data / 100;
        return number_format($data, 2, '.', ',');
    }
}