<?php
include_once(DIR_FS_CATALOG.'ext/modules/payment/alternative_payments/helper/AlternativePaymentsInclude.php');

if (!defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH')) {
    DEFINE('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH',
        'ext/modules/payment/alternative_payments/image/');
}

class AlternativePaymentsPayment
{

    public static function user_side_payment_form()
    {
        $return = self::get_user_side_style();
        $return .= '<div class="form-list" id="payment_form_alternative_payment" style="display:none;">
            <div class="form-horizontal alternative_payments_order_form">
                <fieldset>
                    <div class="alert alert-danger alternative_payment_message_holder" style="display:none;">
                        <span class="message"></span>
                        <button type="button" class="close">×</button>
                    </div>

                    '.self::get_payment_fields().'

                    <input type="hidden" class="input-text" id="payment_method" name="alternative_payment_payment_method" value="alternative_payment_plugin" />
                    <input type="hidden" class="js-state-add-status" name="alternative_payment_state_option_from_ap_form" value="no" />
                    <input type="hidden" class="js-state-add-address-2" name="alternative_payment_address_2_option_from_ap_form" value="no" />
                </fieldset>
            </div>
        </div>';
        $return .= self::get_user_side_script();

        return $return;
    }

    public static function get_payment_fields()
    {
        $entry_payment_options                = self::get_payment_options();
        $alternative_payments_url_img         = MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH;
        $alternative_payments_payment_options = self::get_active_payment_options(array(
                'type' => 'id'));

        $is_sms_active = AlternativePaymentsPayment::get_is_sms_active('SEPA');

        $return = '';


        $return .= '<div class="alternative_payment_preloader" style="padding: 15px; border-left: 1px solid rgb(236, 126, 2);display:none;">
                        <img src="'.$alternative_payments_url_img.'apayment_loader.gif" style="max-height:40px;height:40px;margin-top: -9px;position: absolute;">
                        <span class="message" style="margin-left: 51px;">'.AlternativePaymentsText::en('Loading payment options').'</span>
                    </div>
                    <ul class="col-md-12 alternative_payment_options_select">';

        foreach ($entry_payment_options as $payment_option) {
            if (in_array($payment_option['id'],
                    $alternative_payments_payment_options)) {
                $payment_option['id'] = strtolower($payment_option['id']);
                $fnc_name             = $payment_option['id'];

                $return .= '<li style="list-style: none; display:none;">
                    <div class="form-group" style=" border-bottom: 1px solid #e5e5e5;">
                        <img src="'.$alternative_payments_url_img.$payment_option['id'].'.jpg" style="width:60px; max-height:40px; height:40px; float:right;" />
                        <div style="margin-top: 12px; margin-bottom: 12px; padding-top: 11px;">
                            <input id="alternative_payment_method_option_'.$payment_option['id'].'" type="radio" class="input-radio"
                            name="alternative_payment_method_option" value="'.$payment_option['id'].'" data-order_button_text="" />
                            <label for="alternative_payment_method_option_'.$payment_option['id'].'" class="input-label">'.$payment_option['payment_name'].'</label>
                        </div>
                        <div class="payment_box alternative_payment_method_option_'.$payment_option['id'].'" style="display:none;">
                            '.AlternativePaymentsMethods::$fnc_name($payment_option,
                        $is_sms_active).'
                        </div>
                    </div>
                </li>';
            }
        }
        $return .= '</ul>';

        return $return;
    }

    public static function get_active_payment_options($opt = null)
    {
        $opt = array(
            'type' => isset($opt['type']) ? $opt['type'] : '',
        );

        $name                   = 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_PAYMENT_OPTIONS_';
        $payment_options        = self::get_payment_options();
        $active_payment_options = array();

        $sql = tep_db_query("SELECT `configuration_key`, `configuration_value` FROM ".TABLE_CONFIGURATION." WHERE configuration_key LIKE '".$name."%'");
        while ($row = tep_db_fetch_array($sql)) {
            if ($row['configuration_value'] == 'Active') {
                $key = str_replace($name, '', $row['configuration_key']);
                foreach ($payment_options as $payment) {
                    if (strtolower($payment['id']) == strtolower($key)) {
                        if ($opt['type'] == 'id') {
                            $active_payment_options[] = $payment['id'];
                        } else {
                            $active_payment_options[] = $payment;
                        }
                    }
                }
            }
        }
        return $active_payment_options;
    }

    public static function get_user_side_style()
    {
        return '
<style>
#payment_form_alternative_payment fieldset {
    border: none;
}
#payment_form_alternative_payment .alternative_payment_options_select {
    padding-left: 10px;
}

#payment_form_alternative_payment .alternative_payment_message_holder {
    background-color: rgb(244, 209, 213);
    border-radius: 5px;
    padding: 15px;
    border: 1px solid red;
}
#payment_form_alternative_payment .alternative_payment_message_holder .close {
    float: right;
    background: transparent;
    border: none;
    font-size: 24px;
    margin-top: -6px;
    cursor: pointer;
}
.alternative_payment_options_select .fieldset {
    min-width: 0;
    padding: 0;
    margin: 0;
    border: 0;
}

.alternative_payment_options_select .form-group {
    margin-bottom: 15px;
}
.alternative_payment_options_select label {
    display: inline-block;
    max-width: 100%;
    margin-bottom: 5px;
    font-weight: 700;
}
.alternative_payment_options_select .help-block {
    display: block;
    margin-top: 5px;
    margin-bottom: 10px;
    color: #737373;
    font-size: x-small;
}
.alternative_payment_options_select .form-control {
    display: block;
    width: 100%;
    height: 34px;
    padding: 0px 6px;
    margin-left: -6px;
    font-size: 14px;
    line-height: 1.42857143;
    color: #555;
    background-color: #fff;
    background-image: none;
    border: 1px solid #ccc;
    border-radius: 4px;
    -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
    box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
    -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
    transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
}

.alternative_payment_options_select .btn-success:hover,
.alternative_payment_options_select .btn-success:active,
.alternative_payment_options_select .btn-success.active,
.alternative_payment_options_select .btn-success.disabled,
.alternative_payment_options_select .btn-success[disabled] {
    box-shadow: inset 0 1000px 0 rgba(0, 0, 0, 0.1);
}
.alternative_payment_options_select .btn-success:hover {
    color: #fff;
    background-color: #449d44;
    border-color: #398439;
}
.alternative_payment_options_select .btn.focus, .btn:focus, .btn:hover {
    color: #333;
    text-decoration: none;
}
.alternative_payment_options_select button,
html .alternative_payment_options_select input[type=button],
.alternative_payment_options_select input[type=reset],
.alternative_payment_options_select input[type=submit] {
    -webkit-appearance: button;
    cursor: pointer;
}
.alternative_payment_options_select .btn-success {
    color: #ffffff;
    text-shadow: 0 -1px 0 rgba(0, 0, 0, 0.25);
    background-color: #5bb75b;
    background-image: linear-gradient(to bottom, #62c462, #51a351);
    background-repeat: repeat-x;
    border-color: #51a351 #51a351 #387038;
}
.alternative_payment_options_select .btn {
    padding: 7.5px 12px;
    font-size: 12px;
    border: 1px solid #cccccc;
    border-radius: 4px;
    box-shadow: inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);
}
.alternative_payment_options_select .btn-success {
    color: #fff;
    background-color: #5cb85c;
    border-color: #4cae4c;
}
.alternative_payment_options_select .btn {
    display: inline-block;
    padding: 6px 12px;
    margin-bottom: 0;
    font-size: 14px;
    font-weight: 400;
    line-height: 1.42857143;
    text-align: center;
    white-space: nowrap;
    vertical-align: middle;
    -ms-touch-action: manipulation;
    touch-action: manipulation;
    cursor: pointer;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
    user-select: none;
    background-image: none;
    border: 1px solid transparent;
    border-radius: 4px;
}
.alternative_payment_options_select .payment_box label {
    font-size: 12px;
    font-weight: normal;
}
.alternative_payment_options_select .payment_box .required {
    color: #df280a;
}
.alternative_payment_options_select .payment_box .required:after {
    content: "";
}
.alternative_payment_options_select hr {
    margin-top: 20px;
    margin-bottom: 20px;
    border: 0;
    border-top: 1px solid #eee;
}
.alternative_payment_options_select .input-radio {
    cursor: pointer;
}
.alternative_payment_options_select .input-label {
    cursor: pointer;
}
.alternative_payment_options_select .form-control select.input-text {
    margin-top: 10px;
}
.alternative_payment_options_select select.input-text.form-control {
    margin-bottom: 2px;
}
.alternative_payment_options_select .field_div {
    margin-top: 4px;
    font-size: large;
    width: 8%;
    display: inline-block;
    text-align: center;
    float: left;
}

@media (min-width: 992px) {
    .alternative_payment_options_select .col-md-6 {
        width: 44.5%;
        float: left;
        position: relative;
        min-height: 1px;
        padding-right: 15px;
        padding-left: 15px;
    }
    .alternative_payment_options_select .col-md-12 {
        width: 100%;
        float: left;
        position: relative;
        min-height: 1px;
        padding-right: 15px;
        padding-left: 15px;
    }
}

            </style>';
    }

    public static function get_user_side_script()
    {
        global $order;

        $apPostData = isset($_SESSION["alternative_payment_post_data"]) && $_SESSION["alternative_payment_post_data"]
                ? $_SESSION["alternative_payment_post_data"] : '';

        $selected_payment = isset($apPostData['alternative_payment_method_option'])
            && $apPostData['alternative_payment_method_option'] ? $apPostData['alternative_payment_method_option']
                : '';

        $payment_error = isset($_GET['payment_error']) && $_GET['payment_error']
                ? $_GET['payment_error'] : '';
        $error         = isset($_GET['error']) && $_GET['error'] ? $_GET['error']
                : '';

        $selected_coutry = isset($order->billing['country']['iso_code_2']) && $order->billing['country']['iso_code_2'] ? $order->billing['country']['iso_code_2']: '';
        $address_2 = isset($order->billing['suburb']) && $order->billing['suburb'] ? true : false;

        $display_address_2_field = $address_2?"":"yes";

        $country_url         = tep_href_link('ext/modules/payment/alternative_payments/helper/AlternativePaymentsCallback.php?type=country',
            '', 'SSL');
        $form_validation_url = tep_href_link('ext/modules/payment/alternative_payments/helper/AlternativePaymentsCallback.php?type=form_validation',
            '', 'SSL');
        $phone_url           = tep_href_link('ext/modules/payment/alternative_payments/helper/AlternativePaymentsCallback.php?type=phone_verification',
            '', 'SSL');

        return
            "
<script type=\"text/javascript\">

    jQuery(document).ready(function () {
        /* Call function */
        wolf_apayments();

        $('#payment_form_alternative_payment').closest('tr').find('td').css('vertical-align', 'top');
    });

    function wolf_apayments() {
        'use strict';
        var $ = jQuery;
        var call_country_api = true;
        var validate_status = false;

        var display_field_addres_2 = \"".$display_address_2_field."\";

        display_field_second_address(display_field_addres_2);

        display_error();

        function display_error(){
            var payment_error = '".$payment_error."';
            var error = '".$error."';

            if(payment_error == 'alternative_payments' && error) {
                alert(error);
            }
        }

        /* Check if already selected */
        check_selected_payment();

        $(document).on('click', 'button[type=\"submit\"]', function(){
            if(!validate_status) {
                var selected_payment_method = $('input[name=\"payment\"]:checked').val();
                if (selected_payment_method === 'alternative_payments') {
                    form_validate();
                    return false;
                }
            }
        });

        /* Check if need to display field for second address */
        function display_field_second_address(display){
            if(display == 'yes') {
                $('.js-state-add-address-2').val('yes');
                $('.js-address-2').css('display', 'block');
            }
        }


        function form_validate() {
            var data_send = $('form[name=\"checkout_payment\"]').serializeArray();

            $.ajax({
                type: 'POST',
                url: '".$form_validation_url."',
                data: data_send,
                success: function (data) {
                    if (data.status === \"OK\") {
                        validate_status = true;
                        $('button[type=\"submit\"]').trigger('click');
                    }
                    if (data.status === \"ERROR\") {
                        if (data.msg) {
                            $('.alternative_payment_message_holder .message').html(data.msg);
                            $('.alternative_payment_message_holder').css('display', 'block');

                            $('html,body').animate({
                                      scrollTop: $('.alternative_payment_message_holder').offset().top
                                    }, 1000);
                        }
                    }
                },
                dataType: 'json'
            });
        }

        $('.alternative_payment_message_holder .close').click(function () {
            $('.alternative_payment_message_holder').css('display', 'none');
        });

        set_already_added_values();

        function set_already_added_values() {
            var selected_payment = '".$selected_payment."';
            var id_input = 'alternative_payment_method_option_' + selected_payment;

            $('#' + id_input).attr('checked', 'checked');

            display_payment_box('#' + id_input);

            var payment_value = JSON.parse('".json_encode($apPostData)."');

            var payment_box = $('#' + id_input).closest('li').find('.payment_box');

            payment_box.find('.input-text').each(function(index){
                var field = $(this);
                var name = field.attr('name');
                var list_attr = name.replace(/\[/g, '.');
                list_attr = list_attr.replace(/\]/g, '');
                list_attr = list_attr.split('.');

                var val = '';
                var temp_payment_values = payment_value;
                $.each( list_attr, function( key, value ) {
                    if($.type(temp_payment_values) === 'object' ) {
                        $.each( temp_payment_values, function( k, v ) {
                            if(k == value) {
                                temp_payment_values = v;
                                return false;
                            }
                        });
                        val = temp_payment_values;
                    }                    
                });
                field.val(val);
            });
        }

        $(document).on('change', '.alternative_payment_options_select input[type=\"radio\"]', function () {
            display_payment_box(this);
        });

        function display_payment_box(obj_selected) {
            $(obj_selected).closest('ul').find('.payment_box').css('display', 'none');

            var obj = $(obj_selected).closest('li').find('.payment_box');

            if (obj.css('display') === 'none') {
                obj.css('display', 'block');
            } else {
                obj.css('display', 'none');
            }
        }

        $(document).on('click, change', 'input[name=\"payment\"]', function () {
            check_selected_payment();
        });

        $(document).on('click', '.moduleRowSelected td', function () {
            check_selected_payment();
        });

        function check_selected_payment() {
            var selected_payment_method = $('input[name=\"payment\"]:checked').val();
            if (selected_payment_method === 'alternative_payments') {
                if($('#payment_form_alternative_payment').css('display') !== 'block'){
                    selected_country();
                }
                $('#payment_form_alternative_payment').css('display', 'block');
            } else {
                $('#payment_form_alternative_payment').css('display', 'none');
            }
        }

        $(document).on('click', '#p_method_apayments', function () {
            var apayment_selected = $(this).val();
            if (apayment_selected === 'apayments') {
                selected_country();
            }
        });

        function selected_country() {
            if (!call_country_api) {
                return false;
            }

            $('.alternative_payment_preloader').css('display', 'block');

            call_country_api = false;
            var selected_country = '".$selected_coutry."';

            var data = {
                ajax_temp_selected_country: selected_country
            };
            $.ajax({
                type: 'POST',
                url: '".$country_url."',
                data: data,
                success: function (data) {
                    if (data.status === \"OK\") {
                        
                        $(\".alternative_payment_options_select li\").each(function () {
                            var li_id = $(this).find('.input-radio').val();
                            if ($.inArray(li_id.toLowerCase(), data.payments) < 0) {
                                $(this).css('display', 'none');
                            } else {
                                $(this).css('display', 'block');
                            }
                        });

                        $('ul.alternative_payment_options_select input').each(function () {
                            $(this).removeAttr('disabled');
                        });

                        
                        if(data.states){
                            $('.js-state-add-status').val('yes');

                            var state_holders = $('.js-state-holder');

                            state_holders.each(function(){
                                var state_holder = $(this);
                                var state_select = state_holder.find('select');

                                if(!state_select.val()) {
                                    state_holder.css('display', 'block');

                                    state_select.empty();

                                    var prompt = state_holder.attr('data-prompt-val');
                                    var t = '<option value=\'\'>' + prompt + '</option>';

                                    $.each(data.states, function(key, val){
                                       t += '<option value=\"' + key + '\">' + val + '</option>';
                                    });

                                    state_select.append(t);
                                }
                            });
                        }

                        call_country_api = true;
                    }
                    if (data.status === \"ERROR\") {
                        $('.js-state-add-status').val('no');
                        alert(data.message);
                    }

                    $('.alternative_payment_preloader').css('display', 'none');
                },
                dataType: 'json'
            });
        }

        $(document).on('click', '.alternative_peyment_send_phone_number_btn', function () {

            var phone_number = $('.alternative_payment_phone_number_txt').val();

            if (!phone_number) {
                $('.alternative_payment_message_holder .message').html('Please fill phone number.');
                $('.alternative_payment_message_holder').css('display', 'block');
                return false;
            } else {
                $('.alternative_payment_message_holder').css('display', \"none\");
            }

            var data = {
                ajax_temp_phone: phone_number
            };

            $.ajax({
                type: 'POST',
                url: '".$phone_url."',
                data: data,
                success: function (data) {
                    if (data.status === \"OK\") {
                        if (data.message) {
                            $('.alternative_payment_message_holder .message').html(data.message);
                        }
                        $('.alternative_peyment_phone_number').css('display', \"none\");
                        $('.alternative_peyment_verification_code').css('display', 'block');

                        $('.alternative_payments_response_phone_number').attr('value', data.phone);
                        $('.alternative_payments_response_token').attr('value', data.token);
                    }
                    if (data.status === \"ERROR\") {
                        if (data.message) {
                            $('.alternative_payment_message_holder .message').html(data.message);
                            $('.alternative_payment_message_holder').css('display', 'block');
                        }
                    }
                },
                dataType: 'json'
            });
        });
    }
</script>";
    }

    public static function validate_fields($posted)
    {
        $return = array('status' => 'OK', 'msg' => 'No errors');

        //echo '<pre>' . print_r($posted, true) . '</pre>';
        //return false;

        if (isset($posted['alternative_payment_payment_method']) &&
            $posted['alternative_payment_payment_method'] == 'alternative_payment_plugin') {

            if (isset($posted['alternative_payment_method_option']) &&
                $posted['alternative_payment_method_option']) {

                $selected_payment_option = $posted['alternative_payment_method_option'];

                $entry_payment_options = self::get_payment_options();

                $selected_payment_option_name = '';
                foreach ($entry_payment_options as $row) {
                    if ($row['id'] == $selected_payment_option) {
                        $selected_payment_option_name = $row['payment_name'];
                    }
                }

                $holder_names = isset($posted['alternative_payment_holder_name'])
                        ? $posted['alternative_payment_holder_name'] : '';
                $ibans        = isset($posted['alternative_payment_iban']) ? $posted['alternative_payment_iban']
                        : '';
                $bics         = isset($posted['alternative_payment_bic']) ? $posted['alternative_payment_bic']
                        : '';

                $credit_card_numbers = isset($posted['alternative_payment_credit_card_number'])
                        ? $posted['alternative_payment_credit_card_number'] : '';
                $cvv2s               = isset($posted['alternative_payment_cvv2'])
                        ? $posted['alternative_payment_cvv2'] : '';
                $exp_years           = isset($posted['alternative_payment_exp_year'])
                        ? $posted['alternative_payment_exp_year'] : '';
                $exp_mounths         = isset($posted['alternative_payment_exp_mounth'])
                        ? $posted['alternative_payment_exp_mounth'] : '';
                $credit_card_types   = isset($posted['alternative_payment_credit_card_type'])
                        ? $posted['alternative_payment_credit_card_type'] : '';

                $document_ids = isset($posted['alternative_payment_document_id'])
                        ? $posted['alternative_payment_document_id'] : '';
                $bank_codes   = isset($posted['alternative_payment_bank_code']) ? $posted['alternative_payment_bank_code']
                        : '';

                $birth_date_days    = isset($posted['alternative_payment_birth_date_day'])
                        ? $posted['alternative_payment_birth_date_day'] : '';
                $birth_date_mounths = isset($posted['alternative_payment_birth_date_mounth'])
                        ? $posted['alternative_payment_birth_date_mounth'] : '';
                $birth_date_years   = isset($posted['alternative_payment_birth_date_year'])
                        ? $posted['alternative_payment_birth_date_year'] : '';

                $alternative_payment_states = isset($posted['alternative_payment_state'])
                        ? $posted['alternative_payment_state'] : '';
                $alternative_payment_address_2 = isset($posted['alternative_payment_address_2'])
                        ? $posted['alternative_payment_address_2'] : '';
                $alternative_payment_address_2_option_from_ap_form = isset($posted['alternative_payment_address_2_option_from_ap_form'])
                        ? $posted['alternative_payment_address_2_option_from_ap_form'] : '';



                // Phone verification fields ONLY for SEPA
                if ($selected_payment_option === 'sepa') {
                    if (self::get_is_sms_active($selected_payment_option)) {
                        $phone_numbers          = isset($posted['payment_phone_number'])
                                ? $posted['payment_phone_number'] : '';
                        $respons_phone_numbers  = isset($posted['payment_response_phone_number'])
                                ? $posted['payment_response_phone_number'] : '';
                        $respons_tokens         = isset($posted['payment_response_token'])
                                ? $posted['payment_response_token'] : '';
                        $sms_verification_codes = isset($posted['payment_sms_verification_code'])
                                ? $posted['payment_sms_verification_code'] : '';

                        // Check phone number
                        if (isset($phone_numbers[$selected_payment_option])) {
                            if (empty($phone_numbers[$selected_payment_option])) {
                                $return['status'] = 'ERROR';
                                $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_phone_number');
                                return $return;
                            }
                        }
                        // Check respons phone number
                        if (isset($respons_phone_numbers[$selected_payment_option])) {
                            if (empty($respons_phone_numbers[$selected_payment_option])) {
                                $return['status'] = 'ERROR';
                                $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_response_phone_number');
                                return $return;
                            }
                        }
                        // Check respons token
                        if (isset($respons_tokens[$selected_payment_option])) {
                            if (empty($respons_tokens[$selected_payment_option])) {
                                $return['status'] = 'ERROR';
                                $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_response_token');
                                return $return;
                            }
                        }
                        // Check respons token
                        if (isset($sms_verification_codes[$selected_payment_option])) {
                            if (empty($sms_verification_codes[$selected_payment_option])) {
                                $return['status'] = 'ERROR';
                                $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_verification_code');
                                return $return;
                            }
                        }
                    }
                }
                // Check holder name
                if (isset($holder_names[$selected_payment_option])) {
                    if (empty($holder_names[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_holder');
                        return $return;
                    }
                }
                // Check iban
                if (isset($ibans[$selected_payment_option])) {
                    if (empty($ibans[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_iban');
                        return $return;
                    }
                }
                // Check bic
                if (isset($bics[$selected_payment_option])) {
                    if (empty($bics[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_bic');
                        return $return;
                    }
                }

                // Check credit card number
                if (isset($credit_card_numbers[$selected_payment_option])) {
                    if (empty($credit_card_numbers[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_credit_card_number');
                        return $return;
                    }

                    if (!ctype_digit($credit_card_numbers[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_credit_card_number_not_numbers');
                        return $return;
                    }

                    if (strlen($credit_card_numbers[$selected_payment_option]) > 16) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_credit_card_number_more');
                        return $return;
                    }

                    if (strlen($credit_card_numbers[$selected_payment_option]) < 16) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_credit_card_number_less');
                        return $return;
                    }
                }
                // Check credit card cvv2
                if (isset($cvv2s[$selected_payment_option])) {
                    if (empty($cvv2s[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_cvv2');
                        return $return;
                    }

                    if (!ctype_digit($cvv2s[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_cvv2_not_numbers');
                        return $return;
                    }

                    if (strlen($cvv2s[$selected_payment_option]) > 4) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_cvv2_more');
                        return $return;
                    }

                    if (strlen($cvv2s[$selected_payment_option]) < 3) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_cvv2_less');
                        return $return;
                    }
                }
                // Check credit card types
                if (isset($credit_card_types[$selected_payment_option])) {
                    if (empty($credit_card_types[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_credit_card_types');
                        return $return;
                    }
                }
                // Check exp_mounths
                if (isset($exp_mounths[$selected_payment_option])) {
                    if (empty($exp_mounths[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_exp_mounths');
                        return $return;
                    }
                }
                // Check exp_years
                if (isset($exp_years[$selected_payment_option])) {
                    if (empty($exp_years[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_exp_years');
                        return $return;
                    }
                }

                // Check document id
                if (isset($document_ids[$selected_payment_option])) {
                    if (empty($document_ids[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_document_id');
                        return $return;
                    }
                }
                // Check bank code
                if (isset($bank_codes[$selected_payment_option])) {
                    if (empty($bank_codes[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_bank_code');
                        return $return;
                    }
                }

                // Check birth day
                if (isset($birth_date_days[$selected_payment_option])) {
                    if (empty($birth_date_days[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_birth_date_day');
                        return $return;
                    }
                }
                // Check birth month
                if (isset($birth_date_mounths[$selected_payment_option])) {
                    if (empty($birth_date_mounths[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_birth_date_month');
                        return $return;
                    }
                }
                // Check birth year
                if (isset($birth_date_years[$selected_payment_option])) {
                    if (empty($birth_date_years[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_birth_date_year');
                        return $return;
                    }
                }
                // Check state
                if (isset($alternative_payment_states[$selected_payment_option])) {
                    if (empty($alternative_payment_states[$selected_payment_option])) {
                        $return['status'] = 'ERROR';
                        $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_state');
                        return $return;
                    }
                }
                if($alternative_payment_address_2_option_from_ap_form == 'yes'){
                    if (isset($alternative_payment_address_2[$selected_payment_option])) {
                        if (empty($alternative_payment_address_2[$selected_payment_option])) {
                            $return['status'] = 'ERROR';
                            $return['msg']    = $selected_payment_option_name.' - '.AlternativePaymentsText::en('form_verification_address_2');
                            return $return;
                        }
                    }
                }
            } else {
                $return['status'] = 'ERROR';
                $return['msg']    = AlternativePaymentsText::en('text_error_payment_select');
            }
        }
        return $return;
    }

    public static function get_payments_for_country($country_code)
    {
        $config = AlternativePaymentsFunctions::config_set();

        $Request = new AlternativePaymentsRequest();
        $respons = $Request->get(false, false, $config, false,
            array('country' => $country_code)); // Get config data secret key, public key, api url

        if (isset($respons->Status) && $respons->Status == 'ERROR') {
            $msg = isset($respons->Message) && $respons->Message ? $respons->Message
                    : 'Problem with connection to Alternative Payment';

            $return = array(
                'status' => 'ERROR',
                'message' => $msg,
            );
        } else {
            $payment_methods = array();

            if (isset($respons->paymentOptions) && $respons->paymentOptions) {
                foreach ($respons->paymentOptions as $opt) {
                    $payment_methods[] = strtolower($opt->id);
                }
            }

            $states = array();

            if (isset($respons->states) && $respons->states) {
                foreach ($respons->states as $key => $val) {
                    $states[$key] = $val;
                }
            }

            if ($respons) {
                $return = array(
                    'status' => 'OK',
                    'iso_code_2' => $country_code,
                    'payments' => $payment_methods,
                    'states' => $states,
                );
            } else {

                if(!$config->getProductKey()) {
                    $return = array(
                        'status' => 'ERROR',
                        'message' => 'Alternative Payments - Invalid API keys.'
                    );
                } else {
                    $return = array(
                        'status' => 'ERROR',
                        'message' => 'Alternative Payments - No Payment Option Available.'
                    );
                }
            }
        }

        return $return;
    }

    public static function get_is_sms_active($payment_option = null)
    {
        $config = AlternativePaymentsFunctions::config_set();

        $return = '';

        if($config->getProductKey()){
            $return = AlternativePaymentsSMSVerification::getIsActive($payment_option,
                $config, 'check_is_active');
        }
        
        return isset($return->hasSmsVerification) ? $return->hasSmsVerification : false;
    }

    public static function get_phone_verification($phone_number)
    {
        $config = AlternativePaymentsFunctions::config_set();
        $data   = AlternativePaymentsTransaction::make_transaction_phone_get_code($phone_number,
                $config->getProductKey());

        $respons = AlternativePaymentsSMSVerification::post($data, $config,
                'send_verification_code');

        $status  = (isset($respons->token) && $respons->token) ? "OK" : "ERROR";
        $message = (isset($respons->token) && $respons->token) ? "" : AlternativePaymentsText::en('msg_failed_phone_number');

        if ($status == "OK") {
            $return = array(
                'status' => $status,
                'message' => $message,
                'token' => $respons->token,
                'phone' => $respons->phone,
            );
        } else {
            $return = array(
                'status' => $status,
                'message' => $message
            );
        }
        return $return;
    }

    public static function get_payment_options($id = null)
    {
        $options = array(
            array(
                'id' => 'sepa',
                'enable' => '',
                'payment_name' => 'SEPA',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'eps',
                'enable' => '',
                'payment_name' => 'EPS',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'ideal',
                'enable' => '',
                'payment_name' => 'iDEAL',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'giropay',
                'enable' => '',
                'payment_name' => 'Giropay',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'paysafe',
                'enable' => '',
                'payment_name' => 'PaySafeCard',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'teleingreso',
                'enable' => '',
                'payment_name' => 'TeleIngreso',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'przelewy24',
                'enable' => '',
                'payment_name' => 'Przelewy24',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'bancontact',
                'enable' => '',
                'payment_name' => 'Bancontact',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'safetypay',
                'enable' => '',
                'payment_name' => 'SafetyPay',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'poli',
                'enable' => '',
                'payment_name' => 'POLi',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'qiwi',
                'enable' => '',
                'payment_name' => 'Qiwi',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'sofortuberweisung',
                'enable' => '',
                'payment_name' => 'Sofortuberweisung',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'cashu',
                'enable' => '',
                'payment_name' => 'CashU',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'alipay',
                'enable' => '',
                'payment_name' => 'Alipay',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'TenPay',
                'enable' => '',
                'payment_name' => 'Tenpay',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'UnionPay',
                'enable' => '',
                'payment_name' => 'UnionPay',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'Mangirkart',
                'enable' => '',
                'payment_name' => 'Mangirkart',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'verkkopankki',
                'enable' => '',
                'payment_name' => 'Verkkopankki',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'trustpay',
                'enable' => '',
                'payment_name' => 'TrustPay',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            /* array(
              'id' => 'creditcard',
              'enable' => '',
              'payment_name' => 'Credit card',
              / * 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', * /
              ), */
            array(
                'id' => 'brazilpaybanktransfer',
                'enable' => '',
                'payment_name' => 'BrazilPay Bank Transfer',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'brazilpayboleto',
                'enable' => '',
                'payment_name' => 'BrazilPay Boleto Bancário',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
            array(
                'id' => 'brazilpaychargecard',
                'enable' => '',
                'payment_name' => 'BrazilPay Charge Card',
            /* 'processing_status' => '',
              'product_key' => '',
              'api_key' => '',
              'description' => '', */
            ),
        );

        $return = $options;

        if ($id) {
            $id = strtolower($id);
            foreach ($options as $row) {
                $payment_id = strtolower($row['id']);
                if ($payment_id == $id) {
                    $return = $row;
                }
            }
        }
        return $return;
    }
}