<?php
include_once(DIR_FS_CATALOG.'ext/modules/payment/alternative_payments/helper/AlternativePaymentsInclude.php');

if (!defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH')) {
    DEFINE('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_USER_PATH',
        'ext/modules/payment/alternative_payments/image/');
}

class AlternativePaymentsTransaction
{

    public function transaction($invoice)
    {
        self::saveDataToTblLog('AlternativePaymentsTransaction', 'transaction');

        // Get config data secret key, public key, api url
        $config = AlternativePaymentsFunctions::config_set();

        // Make model for transaction

        //echo '<pre>'.print_r($invoice['order']['is_sms_active'],true).'</pre>';

        if ($invoice['order']['is_sms_active']) {
            $transaction = self::make_transaction_phone_verification($invoice,
                    $config);
        } else {
            $transaction = self::make_transaction($invoice, $config);
        }

        define("SECRET_KEY", $config->getApiKey(), TRUE);

        /*echo '<pre>'.print_r($invoice,true).'</pre>';
        echo '<pre>'.print_r($transaction,true).'</pre>';
        die;*/
        
        // Get response data
        $response = AlternativePaymentsTransactions::post($transaction, $config);

        // Check recived data
        $return = self::checkResponseData($response, $invoice, $config);

        return $return;
    }

    public static function callbackMercahnt($response)
    {
        // Get config data secret key, public key, api url
        $config = AlternativePaymentsFunctions::config_set();

        $invoice = '';

        // Get order id
        $order_id = self::getOrderId($response, $invoice, 'transaction');

        // Get Order
        $order = self::loadOrderByOrderID($order_id);

        // Set order data
        $invoice['order'] = $order;

        // Check recived data
        $return = self::checkResponseData($response, $invoice, $config);

        return $return;
    }

    public static function checkResponseData($response, $invoice, $config)
    {
        self::saveDataToTblLog('Helper_Transaction', 'checkResponseData');

        $return = array();

        $data['response_status_id'] = self::getResponseStatusId($response);
        $data['order_status']       = self::getOrderStatusByResponseStatus($data['response_status_id']);
        $data['return_url']         = self::getRedirectUrl($response, $config);
        $data['payment_option']     = self::getPaymentDesc($response, $invoice);
        $data['order_id']           = self::getOrderId($response, $invoice);
        //$data['transaction_id']   = self::getTransactionId($response, $invoice, 'transaction');

        $data['order_status']['status_id'] = self::getCRMStatusID($data['order_status']['status_id']);
        
        self::saveDataToTblLog('checkResponseData $response',
            json_encode($response));
        self::saveDataToTblLog('checkResponseData $invoice',
            json_encode($invoice));
        self::saveDataToTblLog('checkResponseData $config', json_encode($config));
        self::saveDataToTblLog('checkResponseData $data', json_encode($data));

        /*echo '<pre>'.print_r($response,true).'</pre>';
        echo '<pre>'.print_r($invoice,true).'</pre>';
        echo '<pre>'.print_r($config,true).'</pre>';*/
        //echo '<pre>'.print_r($data,true).'</pre>';
        //die;

        switch (strtolower($data['order_status']['status_name'])) {
            case 'pending':
                if (isset($data['payment_option']['payment_name']) && $data['payment_option']['payment_name']) {
                    self::setOrderHistory($data['order_id'],
                        AlternativePaymentsText::en('Payment option used was ').$data['payment_option']['payment_name']);
                }

                $transaction_id = self::getTransactionId($response, $invoice,
                        'transaction');

                self::setOrderHistory($data['order_id'], AlternativePaymentsText::en('msg_pending').$transaction_id);

                $save_data = array(
                    'order_id' => $data['order_id'],
                    'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_pending').$transaction_id,
                    'data' => json_encode($data),
                );

                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                if ($saved_data['status'] == 'OK') {

                    $return = array(
                        'status' => 'OK',
                        'transaction_id' => $transaction_id,
                        'payment_id' => $data['payment_option']['id'],
                        'payment_name' => $data['payment_option']['payment_name'],
                        'return_url' => $data['return_url'],
                    );
                } else {
                    $return = array(
                        'status' => 'ERROR',
                        'message' => AlternativePaymentsText::en('msg_save_transaction_failed').$data['order_id'],
                    );
                }
                break;
            case 'no_use':
                $return    = array(
                    'status' => 'ERROR',
                    'message' => 'No valid status',
                );
                break;
            case 'invalid_parameter_error':
                $return    = array(
                    'status' => 'ERROR',
                    'message' => 'Alternative payments / Payment option '.$data['payment_option']['payment_name'].' error: '.$response->Message,
                );
                break;
            case 'processing':
                $save_data = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_on_hold'),
                    'data' => json_encode($data),
                );

                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_on_hold'),
                    $data['order_status']['status_id']);

                $return         = array('status' => 'OK');
                break;
            case 'processed':
                $transaction_id = self::getTransactionId($response, $invoice,
                        'transaction');

                if (strtolower($data['payment_option']['id']) == 'brazilpaychargecard'
                    || strtolower($data['payment_option']['id']) == 'creditcard') {

                    /** Check if order already saved */
                    $isTransactionHaveRecords = self::isTransactionHaveRecords($transaction_id);

                    if (!$isTransactionHaveRecords) {
                        // WHAT IS USED
                        if (isset($data['payment_option']['payment_name']) && $data['payment_option']['payment_name']) {
                            self::setOrderHistory($data['order_id'],
                                AlternativePaymentsText::en('Payment option used was ').$data['payment_option']['payment_name']);
                        }
                        // PENDING
                        self::setOrderHistory($data['order_id'] ,AlternativePaymentsText::en('msg_pending').$transaction_id);

                        $save_data  = array(
                            'order_id' => $data['order_id'],
                            'transaction_id' => $transaction_id,
                            'payment_option' => $data['payment_option']['id'],
                            'status' => $data['order_status']['status_id'],
                            'history_note' => AlternativePaymentsText::en('msg_pending').$transaction_id,
                            'data' => json_encode($data),
                        );
                        $saved_data = self::saveDataToTblOrderTransaction($save_data);

                        // PROCCESSING
                        $save_data  = array(
                            'order_id' => $data['order_id'],
                            'transaction_id' => $transaction_id,
                            'payment_option' => $data['payment_option']['id'],
                            'status' => $data['order_status']['status_id'],
                            'history_note' => AlternativePaymentsText::en('msg_proccessing').' if',
                            'data' => json_encode($data),
                        );
                        $saved_data = self::saveDataToTblOrderTransaction($save_data);

                        // Moved to alternative_payments::after_process() as alternative_payment_after_msg
                        /*self::setOrderHistory($data['order_id'],
                            AlternativePaymentsText::en('msg_proccessing'),
                            $data['order_status']['status_id']);*/

                        if ($saved_data['status'] == 'OK') {
                            $return = array(
                                'status' => 'OK',
                                'transaction_id' => $transaction_id,
                                'payment_id' => $data['payment_option']['id'],
                                'payment_name' => $data['payment_option']['payment_name'],
                                'return_url' => $data['return_url'],
                                'after_msg' => array(
                                    'order_id' => $data['order_id'],
                                    'text' => AlternativePaymentsText::en('msg_proccessing'),
                                    'order_status_id' => $data['order_status']['status_id'],
                                )
                            );
                        } else {
                            $return = array(
                                'status' => 'ERROR',
                                'message' => AlternativePaymentsText::en('msg_save_transaction_failed').$data['order_id'],
                            );
                        }
                    } else {
                        $return = array(
                            'status' => 'ERROR',
                            'message' => AlternativePaymentsText::en('msg_save_transaction_failed').$data['order_id'],
                        );
                    }
                } else {
                    $save_data  = array(
                        'order_id' => $data['order_id'],
                        //'transaction_id' => $transaction_id,
                        'payment_option' => $data['payment_option']['id'],
                        'status' => $data['order_status']['status_id'],
                        'history_note' => AlternativePaymentsText::en('msg_proccessing').' else',
                        'data' => json_encode($data),
                    );
                    $saved_data = self::saveDataToTblOrderTransaction($save_data);

                    self::setOrderHistory($data['order_id'],
                        AlternativePaymentsText::en('msg_proccessing'),
                        $data['order_status']['status_id']);

                    $return = array('status' => 'OK');
                }
                break;
            case 'failed':
                $transaction_id = self::getTransactionId($response, $invoice,
                        'transaction');

                /** Check if order already saved */
                $isTransactionHaveRecords = self::isTransactionHaveRecords($transaction_id);

                if (!$isTransactionHaveRecords) {
                    // WHAT IS USED
                    if (isset($data['payment_option']['payment_name']) && $data['payment_option']['payment_name']) {
                        self::setOrderHistory($data['order_id'],
                            AlternativePaymentsText::en('Payment option used was ').$data['payment_option']['payment_name']);
                    }
                    // PENDING
                    self::setOrderHistory($data['order_id'] ,AlternativePaymentsText::en('msg_pending').$transaction_id);

                    $save_data  = array(
                        'order_id' => $data['order_id'],
                        'transaction_id' => $transaction_id,
                        'payment_option' => $data['payment_option']['id'],
                        'status' => $data['order_status']['status_id'],
                        'history_note' => AlternativePaymentsText::en('msg_pending').$transaction_id,
                        'data' => json_encode($data),
                    );
                    $saved_data = self::saveDataToTblOrderTransaction($save_data);

                    self::setOrderHistory($data['order_id'],
                        AlternativePaymentsText::en('msg_pending').$transaction_id);

                    // FAILED
                    $save_data  = array(
                        'order_id' => $data['order_id'],
                        'transaction_id' => $transaction_id,
                        'payment_option' => $data['payment_option']['id'],
                        'status' => $data['order_status']['status_id'],
                        'history_note' => AlternativePaymentsText::en('msg_failed'),
                        'data' => json_encode($data),
                    );
                    $saved_data = self::saveDataToTblOrderTransaction($save_data);

                    if ($saved_data['status'] == 'OK') {
                        $return = array(
                            'status' => 'OK',
                            'transaction_id' => $transaction_id,
                            'payment_id' => $data['payment_option']['id'],
                            'payment_name' => $data['payment_option']['payment_name'],
                            'return_url' => $data['return_url'],
                        );
                    } else {
                        $return = array(
                            'status' => 'ERROR',
                            'message' => AlternativePaymentsText::en('msg_save_transaction_failed').$data['order_id'],
                        );
                    }
                } else {
                    $save_data  = array(
                        'order_id' => $data['order_id'],
                        //'transaction_id' => $transaction_id,
                        'payment_option' => $data['payment_option']['id'],
                        'status' => $data['order_status']['status_id'],
                        'history_note' => AlternativePaymentsText::en('msg_failed'),
                        'data' => json_encode($data),
                    );
                    $saved_data = self::saveDataToTblOrderTransaction($save_data);

                    self::setOrderHistory($data['order_id'],
                        AlternativePaymentsText::en('msg_failed'),
                        $data['order_status']['status_id']);

                    $return = array('status' => 'ERROR', 'message' => AlternativePaymentsText::en('msg_failed_customer'));
                }
                break;
            case 'canceled':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_canceled'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_canceled'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'refund_processing':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_refund_pending'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_refund_pending'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'refunded':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_refunded'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_refunded'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'chargeback':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_chargeback'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_chargeback'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'isf_failed':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_isf_failed'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_isf_failed'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'ERROR', 'message' => AlternativePaymentsText::en('msg_isf_failed_status'));
                break;
            case 'invalid_failed':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_invalid_failed_status'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_invalid_failed_status'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'ERROR', 'message' => AlternativePaymentsText::en('msg_invalid_failed_status'));
                break;
            case 'can_not_be_voided':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_cancel_failed'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_cancel_failed'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'canceled_failed':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_canceled_failed'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_canceled_failed'),
                    $data['order_status']['status_id']);

                $return = array('status' => 'OK');
                break;
            case 'invalid_limit':
                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_invalid_limit'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'ERROR', 'message' => AlternativePaymentsText::en('msg_invalid_limit'));
                break;
            case 'invalid_form_data':
                $return     = array('status' => 'ERROR', 'message' => AlternativePaymentsText::en('invalid_form_data'));
                break;
            case 'has_been_refunded':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_refund_refunded'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_refund_refunded'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'can_not_be_refunded':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_can_not_be_refunded'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_can_not_be_refunded'),
                    $data['order_status']['status_id']);

                $return     = array('status' => 'OK');
                break;
            case 'refund_already_sent':
                $save_data  = array(
                    'order_id' => $data['order_id'],
                    //'transaction_id' => $transaction_id,
                    'payment_option' => $data['payment_option']['id'],
                    'status' => $data['order_status']['status_id'],
                    'history_note' => AlternativePaymentsText::en('msg_refund_already_sent'),
                    'data' => json_encode($data),
                );
                $saved_data = self::saveDataToTblOrderTransaction($save_data);

                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_refund_already_sent'),
                    $data['order_status']['status_id']);

                $return = array('status' => 'OK');
                break;
            case 'error':
            case 'declined_by_acquirer':
                self::setOrderHistory($data['order_id'],
                    AlternativePaymentsText::en('msg_error'),
                    $data['order_status']['status_id']);

                $return = array('status' => 'ERROR', 'message' => AlternativePaymentsText::en('msg_error'));
                break;
        }

        self::saveDataToTblLog('checkResponseData $return', json_encode($return));

        return $return;
    }

    public static function getOrderStatusByResponseStatus($response_status_id)
    {
        self::saveDataToTblLog('Helper_Transaction',
            'getOrderStatusByResponseStatus');
        
        $proccessing_status = AlternativePaymentsFunctions::get_config_value(array(
                'configuration_key' => 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_MERCHANT_TOOL_STATUS'));

        $arr = array(
            'transaction.pending' => array('status_name' => 'pending', 'status_id' => 'pending'),
            'transaction.approved' => array('status_name' => 'processing', 'status_id' => 'processing'),
            'transaction.funded' => array('status_name' => 'processed', 'status_id' => 'funded'),
            'transaction.declined' => array('status_name' => 'failed', 'status_id' => 'failed'),
            'transaction.aborted' => array('status_name' => 'failed', 'status_id' => 'failed'),
            'transaction.chargeback' => array('status_name' => 'chargeback', 'status_id' => 'chargeback'),
            'transaction.isf' => array('status_name' => 'isf_failed', 'status_id' => 'failed'),
            'transaction.invalid' => array('status_name' => 'invalid_failed', 'status_id' => 'failed'),
            'void.succeeded' => array('status_name' => 'canceled', 'status_id' => 'canceled'),
            'void.declined' => array('status_name' => 'failed', 'status_id' => 'failed'),
            'refund.pending' => array('status_name' => 'refund_processing', 'status_id' => 'processing'),
            'refund.succeeded' => array('status_name' => 'refunded', 'status_id' => 'refunded'),
            'refund.declined' => array('status_name' => 'failed', 'status_id' => 'failed'),
            'refund.approved' => array('status_name' => 'refunded', 'status_id' => 'refunded'),
            'customer.created' => array('status_name' => 'no_use', 'status_id' => ''),
            'no.use' => array('status_name' => 'no_use', 'status_id' => ''),
            'canceled_failed' => array('status_name' => 'canceled_failed', 'status_id' => ''),
            'transaction_can_not_be_voided' => array('status_name' => 'can_not_be_voided',
                'status_id' => 'failed'),
            'transaction_can_not_be_refunded' => array('status_name' => 'can_not_be_refunded',
                'status_id' => 'failed'),
            'transaction_has_been_refunded' => array('status_name' => 'has_been_refunded',
                'status_id' => 'failed'),
            'volume_of_transaction_exceeded_limit' => array('status_name' => 'invalid_limit',
                'status_id' => 'failed'),
            'invalid_iban' => array('status_name' => 'invalid_form_data', 'status_id' => 'failed'),
            'information_on_black_list' => array('status_name' => 'invalid_form_data',
                'status_id' => 'failed'),
            'invalid_parameter_error' => array('status_name' => 'invalid_parameter_error',
                'status_id' => 'failed'),
            'missing_required_parameter' => array('status_name' => 'invalid_parameter_error',
                'status_id' => 'failed'),
            'payment_error' => array('status_name' => 'invalid_parameter_error',
                'status_id' => 'failed'),
            'refund_already_sent' => array('status_name' => 'refund_already_sent',
                'status_id' => 'failed'),
            'Pending' => array('status_name' => 'pending', 'status_id' => 'pending'),
            'Created' => array('status_name' => 'pending', 'status_id' => 'pending'),
            'Approved' => array('status_name' => 'processing', 'status_id' => 'processing'),
            'Funded' => array('status_name' => 'processed', 'status_id' => 'funded'),
            'Declined' => array('status_name' => 'failed', 'status_id' => 'failed'),
            'Chargeback' => array('status_name' => 'chargeback', 'status_id' => 'chargeback'),
            'Aborted' => array('status_name' => 'failed', 'status_id' => 'failed'),
        );

        $arr['transaction.'.$proccessing_status] = array('status_name' => 'processed', 'status_id' => 'funded');

        if($proccessing_status == 'approved' && $response_status_id == 'transaction.funded') {
            $response_status_id = 'no.use';
        }
        

        return isset($arr[$response_status_id]) ? $arr[$response_status_id] : '';
    }

    public static function getAPOrderStatus() {
        return array(
            'pending' => array('add' => false, 'name' => 'Pending'),
            'processing' => array('add' => false, 'name' => 'Processing'),
            'funded' => array('add' => true, 'name' => 'Funded [AlternativePayments]'),
            'canceled' => array('add' => true, 'name' => 'Canceled [AlternativePayments]'),
            'failed' => array('add' => true, 'name' => 'Failed [AlternativePayments]'),
            'chargeback' => array('add' => true, 'name' => 'Chargeback [AlternativePayments]'),
            'refunded' => array('add' => true, 'name' => 'Refunded [AlternativePayments]'),
        );
    }

    public static function getCRMStatusID($status_id = null) {
        /**
          osCommerce status
         *
         *
          1 => Pending
          2 => Processing
          3 => Delivered
          4 => PayPal
          5 => Authorize
          6 => Braintree
         *
          // Add
          funded => Funded
          canceled => Canceled
          failed => Failed
          chargeback => Chargeback
          refunded => Refunded

          // Connect
          'transaction.pending' => 'pending',
          'transaction.approved' => 'processing',
          'transaction.funded' => 'complete',
          'transaction.declined' => 'failed',
          'transaction.aborted' => 'failed',
          'transaction.chargeback' => 'chargeback',
          'transaction.isf' => 'failed',
          'transaction.invalid' => 'failed',
          'void.succeeded' => 'canceled',
          'void.declined' => 'failed',
          'refund.pending' => 'processing',
          'refund.succeeded' => 'refunded',
          'refund.declined' => 'failed',
          'refund.approved' => 'refunded',
          'customer.created' => '',
          'canceled_failed' => '',
          'transaction_can_not_be_voided' => 'failed',
          'transaction_can_not_be_refunded' => 'failed',
          'transaction_has_been_refunded' => 'failed',
          'volume_of_transaction_exceeded_limit' => 'failed',
          'invalid_iban' => 'failed',
          'information_on_black_list' => 'failed',
          'invalid_parameter_error' => 'failed',
          'missing_required_parameter' => 'failed',
          'payment_error' => 'failed',
          'refund_already_sent' => 'failed',
          'Pending' => 'pending',
          'Created' => 'pending',
          'Approved' => 'processing',
          'Funded' => 'complete',
          'Declined' => 'failed',
          'Chargeback' => 'chargeback',
          'Aborted' => 'failed',
         */

        /*$arr = array(
            'pending' => 'pending',
            'processing' => 'processing',
            'processed' => 'funded',
            'failed' => 'failed',
            'chargeback' => 'chargeback',
            'isf_failed' => 'failed',
            'invalid_failed' => 'failed',
            'canceled' => 'canceled',
            'refund_processing' => 'processing',
            'refunded' => 'refunded',
            'no_use' => '',
            'canceled_failed' => '',
            'can_not_be_voided' => 'failed',
            'can_not_be_refunded' => 'failed',
            'has_been_refunded' => 'failed',
            'invalid_limit' => 'failed',
            'invalid_form_data' => 'failed',
            'invalid_parameter_error' => 'failed',
            'refund_already_sent' => 'failed',
        );*/

        $return = false;

        if($status_id) {
            $return = self::getDBOrderByStatusName($status_id);
        }

        return $return;
    }

    public static function getDBOrderByStatusName($code){
        $table = TABLE_ALTERNATIVE_PAYMENTS_ORDER_STATUS;
        $sql = 'SELECT * FROM `'.$table.'` WHERE `code` = "'.$code.'"';
        $sql   = tep_db_query($sql);

        while ($row   = tep_db_fetch_array($sql)) {
            $return[] = $row['crm_status_id'];
        }
        $crm_status_id = isset($return[0]) ? $return[0] : 1;
        return $crm_status_id;
    }

    public static function getResponseStatusId($response)
    {
        self::saveDataToTblLog('Helper_Transaction', 'getResponseStatusId');

        if (is_array($response)) {
            $respone_type = isset($response['type']) ? $response['type'] : '';

            if (!$respone_type) {
                $respone_type = (!$respone_type && isset($response['Type'])) ? [
                    'Type'] : $respone_type;
            }

            if (!$respone_type) {
                $respone_type = (!$respone_type && isset($response['status'])) ? $response['status']
                        : $respone_type;
            }

            if (!$respone_type) {
                $respone_type = (!$respone_type && isset($response['Code'])) ? $response['Code']
                        : $respone_type;
            }
        } else {
            $respone_type = isset($response->type) ? $response->type : '';

            if (!$respone_type) {
                $respone_type = (!$respone_type && isset($response->Type)) ? $response->Type
                        : $respone_type;
            }

            if (!$respone_type) {
                $respone_type = (!$respone_type && isset($response->status)) ? $response->status
                        : $respone_type;
            }

            if (!$respone_type) {
                $respone_type = (!$respone_type && isset($response->Code)) ? $response->Code
                        : $respone_type;
            }
        }

        return $respone_type;
    }

    public static function getRedirectUrl($response, $config)
    {
        self::saveDataToTblLog('Helper_Transaction', 'getRedirectUrl');

        if (is_array($response)) {
            $redirect = isset($response['redirectUrl']) && $response['redirectUrl']
                    ? $response['redirectUrl'] : $config->getReturnUrl();
        } else {
            $redirect = isset($response->redirectUrl) && $response->redirectUrl ? $response->redirectUrl
                    : $config->getReturnUrl();
        }
        return $redirect;
    }

    public static function getPaymentDesc($response, $invoice, $type = false)
    {
        self::saveDataToTblLog('Helper_Transaction', 'getPaymentDesc');

        $selected_payment_option = '';

        $selected_payment_option = isset($invoice['payment']['alternative_payment_method_option'])
                ? $invoice['payment']['alternative_payment_method_option'] : '';

        if ($selected_payment_option == '') {
            if (is_array($response)) {
                $selected_payment_option = isset($response['resource']['payment']['paymentOption'])
                        ? strtolower($response['resource']['payment']['paymentOption'])
                        : '';
            } else {
                $selected_payment_option = isset($response->resource->payment->paymentOption)
                        ? strtolower($response->resource->payment->paymentOption)
                        : '';
            }
        }

        $payment_option = AlternativePaymentsPayment::get_payment_options($selected_payment_option);

        switch ($type) {
            case 'name':
                $return = isset($payment_option['payment_name']) ? $payment_option['payment_name']
                        : '';
                break;
            case 'id':
                $return = isset($payment_option['id']) ? $payment_option['id'] : '';
                break;
            default :
                $return = $payment_option;
                break;
        }

        return $return;
    }

    public static function getOrderId($response, $invoice, $type = 'order')
    {
        self::saveDataToTblLog('Helper_Transaction', 'getOrderId');

        $order_id = false;

        switch ($type) {
            case 'order':
                $order_id = isset($invoice['order']['entity_id']) && $invoice['order']['entity_id']
                        ? $invoice['order']['entity_id'] : '';

                $order_id = isset($invoice['order']['orders_id']) && $invoice['order']['orders_id']
                        ? $invoice['order']['orders_id'] : $order_id;
                break;
            case 'transaction':
                if (is_array($response)) {
                    $order_id = isset($response['merchantPassThruData']) && $response['merchantPassThruData']
                            ? $response['merchantPassThruData'] : '';
                } else {
                    $order_id = isset($response->merchantPassThruData) && $response->merchantPassThruData
                            ? $response->merchantPassThruData : '';
                }

                if (!$order_id) {
                    $transaction_id = self::getTransactionId($response,
                            $invoice, 'transaction');

                    $data = array(
                        'transaction_id' => $transaction_id
                    );

                    $order_id = self::getOrderIdByTransactionId($data);
                }

                break;
        }
        return $order_id;
    }

    public static function getTransactionId($response, $invoice,
                                            $type = 'transaction')
    {
        self::saveDataToTblLog('Helper_Transaction', 'getTransactionId');

        $transaction_id = false;

        switch ($type) {
            case 'order':
                $transaction_id = 'Set func selectTransactionIdByOrderId()';
                break;
            case 'transaction':
                if (is_array($response)) {
                    $transaction_id = isset($response['resource']['id']) ? $response['resource']['id']
                            : $response['id'];
                } else {
                    $transaction_id = isset($response->resource->id) ? $response->resource->id
                            : $response->id;
                }
                break;
        }
        return $transaction_id;
    }

    public static function isTransactionHaveRecords($transaction_id)
    {
        self::saveDataToTblLog('Helper_Transaction', 'isTransactionHaveRecords');

        $data = (object) array(
                'transaction_id' => $transaction_id ? $transaction_id : '',
        );

        $alldata = self::getDBData($data);

        if (count($alldata)) {
            $return = true;
        } else {
            $return = false;
        }

        return $return;
    }

    public static function getOrderIdByTransactionId($data)
    {
        self::saveDataToTblLog('Helper_Transaction', 'getOrderIdByTransactionId');

        $data = (object) array(
                'transaction_id' => isset($data['transaction_id']) ? $data['transaction_id']
                    : '',
                'type' => isset($data['type']) ? $data['type'] : '',
                'status' => isset($data['status']) ? $data['status'] : '',
        );

        $alldata = self::getDBData($data);

        if (count($alldata)) {
            $return = $alldata[0]['order_id'];
        } else {
            $return = array('status' => 'ERROR', 'message' => 'No record for send transaction ID');
        }

        return $return;
    }

    public static function getOrderTransactionRowByOrderId($data)
    {
        self::saveDataToTblLog('Helper_Transaction',
            'getOrderTransactionRowByOrderId');

        $data = (object) array(
                'order_id' => isset($data['order_id']) ? $data['order_id'] : '',
        );

        $alldata = self::getDBData($data);

        if (count($alldata)) {
            if (count($alldata) > 1) {
                $return = array('status' => 'ERROR', 'message' => 'More then one order with transaction ID');
            } else {
                $return = $alldata[count($alldata) - 1];
            }
        } else {
            $return = array('status' => 'ERROR', 'message' => 'No record for send transaction ID');
        }

        return $return;
    }

    public static function getDBData($data,
                                     $table = TABLE_ALTERNATIVE_PAYMENTS_ORDER_TRANSACTION)
    {
        self::saveDataToTblLog('Helper_Transaction', 'getDBData');

        $sql = 'SELECT * FROM `'.$table.'` WHERE 1';

        foreach ($data as $column => $value) {
            if ($value) {
                $sql .= ' AND `'.$column.'` = "'.$value.'"';
            }
        }

        $sql   = tep_db_query($sql);
        while ($row = tep_db_fetch_array($sql)) {
            $alldata[] = $row;
        }

        return $alldata;
    }

    public static function loadOrderByOrderID($order_id)
    {

        $data = array(
            'orders_id' => $order_id
        );

        $return = self::getDBData($data, TABLE_ORDERS);

        return isset($return[0]) ? $return[0] : false;
    }

    public static function getMaxOrderID()
    {
        $table = TABLE_ORDERS;
        $sql   = tep_db_query('SELECT * FROM `'.$table.'` ORDER BY `orders_id` DESC LIMIT 1');
        while ($row   = tep_db_fetch_array($sql)) {
            $return[] = $row['orders_id'];
        }
        $max = isset($return[0]) ? $return[0] + 1 : 1;

        return $max;
    }

    public static function setOrderHistory($order_id, $message,
                                           $order_status = null, $date_added = 'now()')
    {
        self::saveDataToTblLog('Helper_Transaction', 'setOrderHistory');

        self::saveDataToTblLog('Helper_Transaction $order_id', $order_id);
        self::saveDataToTblLog('Helper_Transaction $message', $message);
        self::saveDataToTblLog('Helper_Transaction $order_status', $order_status);

        // Get Order
        $sql_data_array = array('orders_id' => $order_id,
            'date_added' => $date_added,
            'customer_notified' => '0',
        );

        // set message
        if ($message) {
            $sql_data_array['comments'] = $message;
        }

        // set status
        if ($order_status) {
            $sql_data_array['orders_status_id'] = (int) $order_status;
        }

        if ($message || $order_status) {
            tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
        }

        if($order_id && $order_status) {
            $data_order = array(
                'edit' => array(
                    'orders_status' => $order_status,
                ),
                'query' => array(
                    'orders_id' => $order_id,
                )
            );
            self::updateDataToTblOrderTransaction($data_order);
        }

        return false;
    }

    public static function saveDataToTblOrderTransaction($data)
    {
        self::saveDataToTblLog('Helper_Transaction',
            'saveDataToTblOrderTransaction');

        $data = (object) array(
                'order_id' => isset($data['order_id']) ? $data['order_id'] : '',
                'transaction_id' => isset($data['transaction_id']) ? $data['transaction_id']
                    : '',
                'payment_option' => isset($data['payment_option']) ? $data['payment_option']
                    : '',
                'status' => isset($data['status']) ? $data['status'] : '',
                'history_note' => isset($data['history_note']) ? $data['history_note']
                    : '',
                'data' => isset($data['data']) ? $data['data'] : '',
        );

        $data->data         = str_replace('"', "'", $data->data);
        $data->history_note = str_replace('"', "'", $data->history_note);

        $table = TABLE_ALTERNATIVE_PAYMENTS_ORDER_TRANSACTION;
        $query = "INSERT INTO `{$table}` "
            ."(`order_id`, `transaction_id`, `payment_option`, `status`, `history_note`, `data`) VALUES "
            ."(\"".$data->order_id."\", \"".$data->transaction_id."\", \"".$data->payment_option."\", \"".$data->status."\", \"".$data->history_note."\", \"".$data->data."\");";

        if (!tep_db_query($query)) {
            return array('status' => 'ERROR', 'message' => 'Data saved to tbl apayments_order_transaction');
        }

        return array('status' => 'OK', 'message' => 'Data saved');
    }


    public static function updateDataToTblOrderTransaction($data, $table = TABLE_ORDERS)
    {
        self::saveDataToTblLog('Helper_Transaction',
            'updateDataToTblOrderTransaction');

        $data = (object) array(
                'edit' => (object) array(
                    'orders_id' => isset($data['edit']['orders_id']) ? $data['edit']['orders_id']
                        : '',
                    'orders_status' => isset($data['edit']['orders_status']) ? $data['edit']['orders_status']
                        : '',
                    'date_added' => isset($data['edit']['date_added']) ? $data['edit']['date_added']
                        : '',
                ),
                'query' => (object) array(
                    'orders_id' => isset($data['query']['orders_id']) ? $data['query']['orders_id']
                        : '',
                    'orders_status' => isset($data['query']['orders_status']) ? $data['query']['orders_status']
                        : '',
                    'orders_status_id' => isset($data['query']['orders_status_id']) ? $data['query']['orders_status_id']
                        : '',
                )
        );

        $query = '';
        $binds = array();

        $fields    = '';
        $condition = '1 ';

        foreach ($data as $field => $val) {
            if ($field == 'edit') {
                foreach ($val as $f => $v) {
                    if ($v) {
                        if($f == 'date_added') {
                            $fields .= '`'.$f.'` = '.$v.', ';
                        } else {
                            $fields .= '`'.$f.'` = "'.$v.'", ';
                        }
                    }
                }
            }
            if ($field == 'query') {
                foreach ($val as $f => $v) {
                    if ($v) {
                        $condition .= 'AND `'.$f.'` = "'.$v.'" ';
                    }
                }
            }
        }

        $fields = substr($fields, 0, -2);
        $query  = 'UPDATE `'.$table.'` SET '.$fields.' WHERE '.$condition;

        self::saveDataToTblLog('Proba 1234',
            $query);

        if (!tep_db_query($query)) {
            return array('status' => 'ERROR', 'message' => 'Data saved to tbl apayments_order_transaction');
        }
        return array('status' => 'OK', 'message' => 'Data saved');
    }

    public static function saveDataToTblLog($dev_info, $dev_info_additional)
    {
        $table = TABLE_ALTERNATIVE_PAYMENTS_LOG;

        $dev_info_additional = str_replace('"', "'", $dev_info_additional);

        $query = "INSERT INTO `{$table}` "
            ."(`dev_info`, `dev_info_additional`) VALUES "
            ."(\"".$dev_info."\", \"".$dev_info_additional."\");";

        if (!tep_db_query($query)) {
            return array('status' => 'ERROR', 'message' => 'Data saved to tbl apayments_order_transaction');
        }

        return array('status' => 'OK', 'message' => 'Data saved');
    }

    public static function make_transaction($invoice, $config)
    {
        self::saveDataToTblLog('Helper_Payment', 'makeTransaction');

        $selected_payment_option = $invoice['payment']['alternative_payment_method_option'];

        $customer = new AlternativePaymentsCustomerModel();
        $customer->setEmail($invoice['customer']['email']);
        $customer->setFirstName($invoice['customer']['firstname']);
        $customer->setLastName($invoice['customer']['lastname']);
        $customer->setAddress($invoice['customer']['street_address']);
        $customer->setAddress2($invoice['customer']['suburb']);
        $customer->setCity($invoice['customer']['city']);
        $customer->setZip($invoice['customer']['postcode']);
        $customer->setCountry($invoice['customer']['country']['iso_code_2']);
        $customer->setState($invoice['customer']['state']);
        $customer->setPhone($invoice['customer']['telephone']);

        $birth_date_days    = isset($invoice['payment']['alternative_payment_birth_date_day'])
                ? $invoice['payment']['alternative_payment_birth_date_day'] : '';
        $birth_date_mounths = isset($invoice['payment']['alternative_payment_birth_date_mounth'])
                ? $invoice['payment']['alternative_payment_birth_date_mounth'] : '';
        $birth_date_years   = isset($invoice['payment']['alternative_payment_birth_date_year'])
                ? $invoice['payment']['alternative_payment_birth_date_year'] : '';

        if (isset($birth_date_days[$selected_payment_option]) &&
            isset($birth_date_mounths[$selected_payment_option]) &&
            isset($birth_date_years[$selected_payment_option])) {

            $bd = $birth_date_mounths[$selected_payment_option]."/".$birth_date_days[$selected_payment_option]."/".$birth_date_years[$selected_payment_option];
            $customer->setBirthDate($bd);
        }

        $payment = new AlternativePaymentsPaymentModel();

        $holder_names = isset($invoice['payment']['alternative_payment_holder_name'])
                ? $invoice['payment']['alternative_payment_holder_name'] : '';
        $ibans        = isset($invoice['payment']['alternative_payment_iban']) ? $invoice['payment']['alternative_payment_iban']
                : '';
        $bics         = isset($invoice['payment']['alternative_payment_bic']) ? $invoice['payment']['alternative_payment_bic']
                : '';

        $credit_card_numbers = isset($invoice['payment']['alternative_payment_credit_card_number'])
                ? $invoice['payment']['alternative_payment_credit_card_number'] : '';
        $cvv2s               = isset($invoice['payment']['alternative_payment_cvv2'])
                ? $invoice['payment']['alternative_payment_cvv2'] : '';
        $exp_years           = isset($invoice['payment']['alternative_payment_exp_year'])
                ? $invoice['payment']['alternative_payment_exp_year'] : '';
        $exp_mounths         = isset($invoice['payment']['alternative_payment_exp_mounth'])
                ? $invoice['payment']['alternative_payment_exp_mounth'] : '';
        $credit_card_types   = isset($invoice['payment']['alternative_payment_credit_card_type'])
                ? $invoice['payment']['alternative_payment_credit_card_type'] : '';

        $document_ids = isset($invoice['payment']['alternative_payment_document_id'])
                ? $invoice['payment']['alternative_payment_document_id'] : '';
        $bank_codes   = isset($invoice['payment']['alternative_payment_bank_code'])
                ? $invoice['payment']['alternative_payment_bank_code'] : '';

        $payment->setPaymentOption($selected_payment_option);

        if (isset($holder_names[$selected_payment_option])) {
            $payment->setHolder($holder_names[$selected_payment_option]);
        }
        if (isset($ibans[$selected_payment_option])) {
            $payment->setIBAN($ibans[$selected_payment_option]);
        }
        if (isset($bics[$selected_payment_option])) {
            $payment->setBIC($bics[$selected_payment_option]);
        }

        if (isset($credit_card_numbers[$selected_payment_option])) {
            $credit_card_numbers_val = str_replace('.', '',
                $credit_card_numbers[$selected_payment_option]);
            $credit_card_numbers_val = str_replace(' ', '',
                $credit_card_numbers_val);
            $payment->setCreditCardNumber($credit_card_numbers_val);
        }
        if (isset($cvv2s[$selected_payment_option])) {
            $payment->setCvv2($cvv2s[$selected_payment_option]);
        }
        if (isset($exp_years[$selected_payment_option])) {
            $payment->setExpYear($exp_years[$selected_payment_option]);
        }
        if (isset($exp_mounths[$selected_payment_option])) {
            $payment->setExpMounth($exp_mounths[$selected_payment_option]);
        }
        if (isset($credit_card_types[$selected_payment_option])) {
            $payment->setCreditCardType($credit_card_types[$selected_payment_option]);
        }

        if (isset($document_ids[$selected_payment_option])) {
            $payment->setDocumentId($document_ids[$selected_payment_option]);
        }
        if (isset($bank_codes[$selected_payment_option])) {
            $payment->setBankCode($bank_codes[$selected_payment_option]);
        }

        $redirect_url = new AlternativePaymentsRedirectUrls();
        $redirect_url->setReturnUrl($config->getReturnUrl());
        $redirect_url->setCancelUrl($config->getCancelUrl());

        $transaction = new AlternativePaymentsTransactionModel();
        $transaction->setCustomer($customer);
        $transaction->setPayment($payment);
        $transaction->setRedirectUrls($redirect_url);

        $transaction->setMerchantPassThruData($invoice['order']['entity_id']);

        $transaction_items = AlternativePaymentsFunctions::getOrderItems($invoice);
        $transaction->setDescription($transaction_items);

        $transaction_amount = AlternativePaymentsFunctions::decode_amount($invoice['order']['total']);
        $transaction->setAmount($transaction_amount);
        $transaction->setCurrency($invoice['order']['currency']);

        $transaction_ip = AlternativePaymentsFunctions::getUserIp();
        $transaction->setIPAddress($transaction_ip);

        return $transaction;
    }

    public static function make_transaction_phone_verification($invoice, $config)
    {
        self::saveDataToTblLog('Helper_Payment', 'makeTransaction');

        $selected_payment_option = $invoice['payment']['alternative_payment_method_option'];

        $customer = new AlternativePaymentsCustomerModel();
        $customer->setEmail($invoice['customer']['email']);
        $customer->setFirstName($invoice['customer']['firstname']);
        $customer->setLastName($invoice['customer']['lastname']);
        $customer->setAddress($invoice['customer']['street_address']);
        $customer->setAddress2($invoice['customer']['suburb']);
        $customer->setCity($invoice['customer']['city']);
        $customer->setZip($invoice['customer']['postcode']);
        $customer->setCountry($invoice['customer']['country']['iso_code_2']);
        $customer->setState($invoice['customer']['state']);
        $customer->setPhone($invoice['customer']['telephone']);

        $birth_date_days    = isset($invoice['payment']['alternative_payment_birth_date_day'])
                ? $invoice['payment']['alternative_payment_birth_date_day'] : '';
        $birth_date_mounths = isset($invoice['payment']['alternative_payment_birth_date_mounth'])
                ? $invoice['payment']['alternative_payment_birth_date_mounth'] : '';
        $birth_date_years   = isset($invoice['payment']['alternative_payment_birth_date_year'])
                ? $invoice['payment']['alternative_payment_birth_date_year'] : '';

        if (isset($birth_date_days[$selected_payment_option]) &&
            isset($birth_date_mounths[$selected_payment_option]) &&
            isset($birth_date_years[$selected_payment_option])) {

            $bd = $birth_date_mounths[$selected_payment_option]."/".$birth_date_days[$selected_payment_option]."/".$birth_date_years[$selected_payment_option];
            $customer->setBirthDate($bd);
        }

        $payment = new AlternativePaymentsPaymentModel();

        $holder_names = isset($invoice['payment']['alternative_payment_holder_name'])
                ? $invoice['payment']['alternative_payment_holder_name'] : '';
        $ibans        = isset($invoice['payment']['alternative_payment_iban']) ? $invoice['payment']['alternative_payment_iban']
                : '';
        $bics         = isset($invoice['payment']['alternative_payment_bic']) ? $invoice['payment']['alternative_payment_bic']
                : '';

        $credit_card_numbers = isset($invoice['payment']['alternative_payment_credit_card_number'])
                ? $invoice['payment']['alternative_payment_credit_card_number'] : '';
        $cvv2s               = isset($invoice['payment']['alternative_payment_cvv2'])
                ? $invoice['payment']['alternative_payment_cvv2'] : '';
        $exp_years           = isset($invoice['payment']['alternative_payment_exp_year'])
                ? $invoice['payment']['alternative_payment_exp_year'] : '';
        $exp_mounths         = isset($invoice['payment']['alternative_payment_exp_mounth'])
                ? $invoice['payment']['alternative_payment_exp_mounth'] : '';
        $credit_card_types   = isset($invoice['payment']['alternative_payment_credit_card_type'])
                ? $invoice['payment']['alternative_payment_credit_card_type'] : '';

        $document_ids = isset($invoice['payment']['alternative_payment_document_id'])
                ? $invoice['payment']['alternative_payment_document_id'] : '';
        $bank_codes   = isset($invoice['payment']['alternative_payment_bank_code'])
                ? $invoice['payment']['alternative_payment_bank_code'] : '';

        $payment->setPaymentOption($selected_payment_option);

        if (isset($holder_names[$selected_payment_option])) {
            $payment->setHolder($holder_names[$selected_payment_option]);
        }
        if (isset($ibans[$selected_payment_option])) {
            $payment->setIBAN($ibans[$selected_payment_option]);
        }
        if (isset($bics[$selected_payment_option])) {
            $payment->setBIC($bics[$selected_payment_option]);
        }

        if (isset($credit_card_numbers[$selected_payment_option])) {
            $credit_card_numbers_val = str_replace('.', '',
                $credit_card_numbers[$selected_payment_option]);
            $credit_card_numbers_val = str_replace(' ', '',
                $credit_card_numbers_val);
            $payment->setCreditCardNumber($credit_card_numbers_val);
        }
        if (isset($cvv2s[$selected_payment_option])) {
            $payment->setCvv2($cvv2s[$selected_payment_option]);
        }
        if (isset($exp_years[$selected_payment_option])) {
            $payment->setExpYear($exp_years[$selected_payment_option]);
        }
        if (isset($exp_mounths[$selected_payment_option])) {
            $payment->setExpMounth($exp_mounths[$selected_payment_option]);
        }
        if (isset($credit_card_types[$selected_payment_option])) {
            $payment->setCreditCardType($credit_card_types[$selected_payment_option]);
        }

        if (isset($document_ids[$selected_payment_option])) {
            $payment->setDocumentId($document_ids[$selected_payment_option]);
        }
        if (isset($bank_codes[$selected_payment_option])) {
            $payment->setBankCode($bank_codes[$selected_payment_option]);
        }

        $redirect_url = new AlternativePaymentsRedirectUrls();
        $redirect_url->setReturnUrl($config->getReturnUrl());
        $redirect_url->setCancelUrl($config->getCancelUrl());

        $transaction = new AlternativePaymentsTransactionModel();
        $transaction->setCustomer($customer);
        $transaction->setPayment($payment);
        $transaction->setRedirectUrls($redirect_url);

        $transaction->setMerchantPassThruData($invoice['order']['entity_id']);

        $transaction_items = AlternativePaymentsFunctions::getOrderItems($invoice);
        $transaction->setDescription($transaction_items);

        $transaction_amount = AlternativePaymentsFunctions::decode_amount($invoice['order']['total']);
        $transaction->setAmount($transaction_amount);
        $transaction->setCurrency($invoice['order']['currency']);

        $transaction_ip = AlternativePaymentsFunctions::getUserIp();
        $transaction->setIPAddress($transaction_ip);

        $phoneVerification = new AlternativePaymentsPhoneVerification();

        $tokens = isset($invoice['payment']['payment_response_token']) ? $invoice['payment']['payment_response_token']
                : '';
        $pins   = isset($invoice['payment']['payment_sms_verification_code']) ? $invoice['payment']['payment_sms_verification_code']
                : '';
        $phone_number   = isset($invoice['payment']['payment_response_phone_number']) ? $invoice['payment']['payment_response_phone_number']
                : '';

        if (isset($tokens[$selected_payment_option])) {
            $phoneVerification->setToken($tokens[$selected_payment_option]);
        }
        if (isset($pins[$selected_payment_option])) {
            $phoneVerification->setPin($pins[$selected_payment_option]);
        }
        if (isset($phone_number[$selected_payment_option])) {
            $phoneVerification->setPhoneNumber($phone_number[$selected_payment_option]);
        }

        $transaction->setPhoneVerification($phoneVerification);

        return $transaction;
    }

    public static function make_transaction_phone_get_code($phone_number,
                                                           $product_key)
    {

        $phoneVerification = new AlternativePaymentsPhoneVerification();
        $phoneVerification->setPhoneNumber($phone_number);
        $phoneVerification->setProductKey($product_key);

        return $phoneVerification;
    }
}