<?php
require_once(DIR_FS_CATALOG.'ext/modules/payment/alternative_payments/helper/AlternativePaymentsInclude.php');

if (!defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_ADMIN_PATH')) {
    DEFINE('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_ADMIN_PATH',
        'ext/modules/payment/alternative_payments/image/');
}

global $alternative_payment_post_data;

class alternative_payments
{
    var $code, $title, $description, $enabled;

    function alternative_payments()
    {
        global $order;

        $this->signature   = 'alternative_payments|1.0';
        $this->api_version = '1.0';

        $this->code         = 'alternative_payments';
        $this->title        = AlternativePaymentsText::en('method_title');
        $this->description  = AlternativePaymentsText::en('method_description');
        $this->sort_order   = defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SORT_ORDER')
                ? MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_SORT_ORDER : 0;
        $this->enabled      = defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_STATUS')
            && (MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_STATUS == 'True') ? true : false;
        $this->order_status = defined('MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_ORDER_STATUS_ID')
            && ((int) MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_ORDER_STATUS_ID > 0) ? (int) MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_ORDER_STATUS_ID
                : 0;

        define('TABLE_ALTERNATIVE_PAYMENTS_LOG', 'alternative_payments_log');
        define('TABLE_ALTERNATIVE_PAYMENTS_ORDER_TRANSACTION',
            'alternative_payments_order_transaction');
        define('TABLE_ALTERNATIVE_PAYMENTS_ORDER_STATUS',
            'alternative_payments_order_status');

        if ($this->enabled === true) {
            if (isset($order) && is_object($order)) {
                $this->update_status();
            }
        }
    }

    function update_status()
    {
        global $order;
    }

    function javascript_validation()
    {
        return false;
    }

    function selection()
    {
        $fields = AlternativePaymentsPayment::user_side_payment_form();

        return array('id' => $this->code,
            'module' => $this->title.$fields);
    }

    function pre_confirmation_check()
    {
        global $order;

        $apPostData = isset($_SESSION["alternative_payment_post_data"]) ? $_SESSION["alternative_payment_post_data"] : '';

        $paymet_code = isset($apPostData['alternative_payment_method_option'])?$apPostData['alternative_payment_method_option']:'';

        if($paymet_code) {
            $paymet_img = $paymet_code;
            $paymet_name = AlternativePaymentsPayment::get_payment_options($paymet_code);
            $paymet_name = $paymet_name['payment_name'];
            $paymet_title = '<img src="'.MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_ADMIN_PATH. $paymet_img . '.jpg" '
            . 'style="width:auto; height: 30px;" /> '
            . $paymet_name
            . ' power by <img src="'.MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_IMAGE_ADMIN_PATH.'alternative_payment_logo.png" '
            . 'style="width:auto; height: 15px;"/>';

             $order->info['payment_method'] = $paymet_title;
        }
        return false;
    }

    function confirmation()
    {
        return false;
    }

    function process_button()
    {
        echo '<script>
            var $alternative_payment_click_counter = 0;
            $(document).on("click", "button[type=\"submit\"]", function(){
                if(Number($alternative_payment_click_counter) == 1){
                    $(this).attr("disabled", "disabled");
                }
                $alternative_payment_click_counter = Number($alternative_payment_click_counter) + Number(1);
            });
        </script>';
        return false;
    }

    function before_process()
    {
        global $order, $payment_modules;
        //echo '<pre>'.print_r($this->order_id,true).'</pre>';

        $apPostData = $_SESSION["alternative_payment_post_data"];

        $response = '';

        if (isset($payment_modules->selected_module) && $payment_modules->selected_module
            == 'alternative_payments') {
            $payment_option = isset($apPostData['alternative_payment_method_option'])
                    ? $apPostData['alternative_payment_method_option'] : '';
            $invoice        = array();

            /** Get customer data */
            $billingData              = $order->billing;
            $billingData['telephone'] = $order->customer['telephone'];
            $billingData ['email']    = $order->customer['email_address'];

            if ($apPostData['alternative_payment_state_option_from_ap_form'] == 'yes') {
                $billingData['state'] = $apPostData['alternative_payment_state'][$payment_option];
            }
            if ($apPostData['alternative_payment_address_2_option_from_ap_form'] == 'yes') {
                $billingData['suburb'] = $apPostData['alternative_payment_address_2'][$payment_option];
            }

            /** Get items */
            $invoice['products'] = $order->products;

            $invoice['order']                                      = $order->info;
            $invoice['order']['entity_id']                         = AlternativePaymentsTransaction::getMaxOrderID();
            $invoice['order']['alternative_payment_method_option'] = $payment_option;
            $invoice['order']['is_sms_active']                     = AlternativePaymentsPayment::get_is_sms_active('SEPA');
            $invoice['customer']                                   = $billingData;
            $invoice['payment']                                    = $apPostData;

            $response = AlternativePaymentsTransaction::transaction($invoice);
        }

        /** Check transaction status */
        if (isset($response['status']) && $response['status'] == 'ERROR') {
            tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT,
                    'payment_error='.$this->code.'&error='.$response['message']));
        } else {
            $_SESSION["alternative_payment_redirect"]  = isset($response['return_url'])
                    ? $response['return_url'] : '';
            $_SESSION["alternative_payment_post_data"] = '';
            AlternativePaymentsTransaction::saveDataToTblLog('Model_Standard authorize',
                json_encode($response));

            $_SESSION["alternative_payment_after_msg"] = isset($response['after_msg']) ? $response['after_msg'] : '';

        }

        return false;
    }

    function after_process()
    {
        global $cart;
        $cart->reset(true);


        if($_SESSION["alternative_payment_after_msg"]) {
            $msg_data = $_SESSION["alternative_payment_after_msg"];
            if(isset($msg_data['order_id']) && $msg_data['order_id'] &&
                isset($msg_data['text']) && $msg_data['text']){
                AlternativePaymentsTransaction::setOrderHistory(
                    $msg_data['order_id'], $msg_data['text'], $msg_data['order_status_id']);
            }
        }

        $_SESSION["alternative_payment_after_msg"] = '';


        if ($_SESSION["alternative_payment_redirect"]) {
            tep_redirect($_SESSION["alternative_payment_redirect"]);
        }

        $_SESSION["alternative_payment_redirect"]       = '';


        
        
        return false;
    }

    function get_error()
    {
        return false;
    }

    function check()
    {
        if (!isset($this->_check)) {
            $check_query  = tep_db_query("select configuration_value from ".TABLE_CONFIGURATION." where configuration_key = 'MODULE_PAYMENT_ALTERNATIVE_PAYMENTS_STATUS'");
            $this->_check = tep_db_num_rows($check_query);
        }
        return $this->_check;
    }

    function install()
    {
        $install_fields = AlternativePaymentsFunctions::install_fields();

        foreach ($install_fields as $field) {
            $sql = "INSERT INTO ".TABLE_CONFIGURATION." (:columns) VALUES (:values)";

            $column = '';
            $values = '';

            foreach ($field as $col => $val) {
                if ($val != 'not-used') {
                    $column .= '`'.$col.'`, ';
                    $values .= "'".$val."', ";
                }
            }

            $column = substr($column, 0, -2);
            $values = substr($values, 0, -2);

            $sql = str_replace(':columns', $column, $sql);
            $sql = str_replace(':values', $values, $sql);

            tep_db_query($sql);
        }

        $sql = "
            CREATE TABLE IF NOT EXISTS `".TABLE_ALTERNATIVE_PAYMENTS_LOG."` (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `entry_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                `version` varchar(25) NOT NULL COLLATE utf8_unicode_ci,
                `merchant_info` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
                `dev_info` text COLLATE utf8_unicode_ci DEFAULT NULL,
                `dev_info_additional` text COLLATE utf8_unicode_ci DEFAULT NULL,
                PRIMARY KEY (`id`)
            ) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci;";

        tep_db_query($sql);

        $sql = "
            CREATE TABLE IF NOT EXISTS `".TABLE_ALTERNATIVE_PAYMENTS_ORDER_TRANSACTION."` (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `order_id` int(11) NOT NULL,
                `transaction_id` varchar(31) NOT NULL,
                `payment_option` varchar(31) NOT NULL,
                `status` varchar(17) NOT NULL,
                `history_note` text NOT NULL,
                `data` text NOT NULL,
                `create_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                PRIMARY KEY (`id`)
            ) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;
        ";

        tep_db_query($sql);

        /* Create status table */
        $sql = "
            CREATE TABLE IF NOT EXISTS `".TABLE_ALTERNATIVE_PAYMENTS_ORDER_STATUS."` (
                `id` int(11) NOT NULL AUTO_INCREMENT,
                `code` varchar(31) NOT NULL,
                `crm_status_id` varchar(31) NOT NULL,
                `name` varchar(31) NOT NULL,
                PRIMARY KEY (`id`)
            ) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;
        ";

        tep_db_query($sql);

        /* Insert AP status value */
        $ap_status = AlternativePaymentsTransaction::getAPOrderStatus();
        if ($ap_status) {

            foreach ($ap_status as $code => $row) {
                $sql = "INSERT INTO ".TABLE_ALTERNATIVE_PAYMENTS_ORDER_STATUS." (:columns) VALUES (:values)";

                $columns = '`code`, `name`';
                $values  = "'".$code."', '".$row['name']."'";

                $sql = str_replace(':columns', $columns, $sql);
                $sql = str_replace(':values', $values, $sql);

                tep_db_query($sql);
            }

            foreach ($ap_status as $code => $row) {
                if ($row['add']) {
                    $table = TABLE_ORDERS_STATUS;

                    // get new status id
                    $sql    = tep_db_query('SELECT * FROM `'.$table.'` ORDER BY `orders_status_id` DESC LIMIT 1');
                    $return = array();
                    while ($row_db = tep_db_fetch_array($sql)) {
                        $return[] = $row_db['orders_status_id'];
                    }
                    $new_status = isset($return[0]) ? $return[0] + 1 : 1;

                    // add to crm
                    $sql     = "INSERT INTO ".$table." (:columns) VALUES (:values)";
                    $columns = '`orders_status_id`, `language_id`, `orders_status_name`, `public_flag`, `downloads_flag`';
                    $values  = "$new_status, 1, \"".$row['name']."\", 1, 0";

                    $sql = str_replace(':columns', $columns, $sql);
                    $sql = str_replace(':values', $values, $sql);

                    tep_db_query($sql);

                    $crm_status_id = $new_status;
                } else {
                    // get status id by name
                    $table = TABLE_ORDERS_STATUS;

                    $sql    = tep_db_query('SELECT * FROM `'.$table.'` WHERE `orders_status_name` = "'.$row['name'].'"');
                    $return = array();
                    while ($row_db = tep_db_fetch_array($sql)) {
                        $return[] = $row_db['orders_status_id'];
                    }
                    $new_status = isset($return[0]) ? $return[0] : 0;

                    $crm_status_id = $new_status;
                }

                $fields    = '`crm_status_id` = "'.$crm_status_id.'"';
                $condition = '`code` = "'.$code.'"';

                // update ap status
                $query = 'UPDATE `'.TABLE_ALTERNATIVE_PAYMENTS_ORDER_STATUS.'` SET '.$fields.' WHERE '.$condition;
                tep_db_query($query);
            }
        }

        /* Connect */
    }

    function remove()
    {
        tep_db_query("DELETE FROM ".TABLE_CONFIGURATION." WHERE configuration_key IN ('".implode("', '", $this->keys())."')");

        tep_db_query("TRUNCATE TABLE `".TABLE_ALTERNATIVE_PAYMENTS_ORDER_STATUS."`");

        tep_db_query("DELETE FROM `".TABLE_ORDERS_STATUS."` WHERE `orders_status_name` LIKE \"%[AlternativePayments]%\"");
    }

    function keys()
    {
        $install_fields = AlternativePaymentsFunctions::install_fields();
        $keys           = array();

        foreach ($install_fields as $key => $val) {
            $keys[] = $key;
        }

        return $keys;
    }

    function get_alternative_payment_merchant_tool_status($value, $key = '')
    {
        $attr = '';
        $name = $key ? 'configuration['.$key.']' : 'configuration_value';

        $val = AlternativePaymentsText::en('entry_merchant_tool_status');

        $val = explode(';', $val);

        foreach ($val as $v) {
            $v           = explode('=>', $v);
            $opt_array[] = array('id' => $v[0], 'text' => $v[0].' - '.$v[1]);
        }

        return tep_draw_pull_down_menu($name, $opt_array, $value, $attr);
    }

    function get_alternative_payment_merchant_get_sms_verification($value, $key = '')
    {
        $attr = '';
        $name = $key ? 'configuration['.$key.']' : 'configuration_value';

        $config = AlternativePaymentsFunctions::config_set();

        if($config->getProductKey()){
            $is_active = AlternativePaymentsPayment::get_is_sms_active('SEPA');
            $text = $is_active ? AlternativePaymentsText::en('sms_active_true')
                : AlternativePaymentsText::en('sms_active_false');
        } else {
            $text = AlternativePaymentsText::en('Can\'t get status because API keys not set' );
        }
        

        

        $opt_array[] = array('id' => AlternativePaymentsText::en('sms_active_default_value'), 'text' => $text);
        
        return tep_draw_pull_down_menu($name, $opt_array, $value, $attr);
    }

}